.NOLIST
.INCLUDE "8515def.inc"
.LIST

.DEF temp =	r16
.DEF loop =	r17
;.DEF i2c_eep_data	= r22
;.DEF i2c_eep_adr	= r23
;.DEF i2c_data       = r24	; data to send / receive
;.DEF i2c_delay_reg  = r25	; used in i2c_delay

.DSEG
ram_array1:		.BYTE 16
ram_array2:		.BYTE 16

.CSEG
.ORG	0x0
	rjmp	RESET
  
RESET:

	ldi	temp, LOW(RAMEND)  
	out	SPL, temp
	ldi	temp, HIGH(RAMEND)
	out	SPH, temp


	rcall	del_i2c_eep

	ldi	temp, 16
	
	ldi	ZL, LOW(flash_array)
	ldi	ZH, HIGH(flash_array)

	lsl	ZL	;create word oriented adress
	rol	ZH
		
	ldi	YL, LOW(ram_array1)
	ldi	YH, HIGH(ram_array1)
	
next1:
	lpm
	adiw	ZL, 1
	
	st	Y+, r0
	
	dec	temp
	brne	next1


	ldi	i2c_eep_adr, 0x23  
	ldi	i2c_eep_data, 0x8	;lenght
	ldi	ZL, LOW(ram_array1)
	ldi	ZH, HIGH(ram_array1)

	rcall	i2c_eep_page_write


;	ldi	i2c_eep_adr, 0x0
;	ldi	i2c_eep_data, 0x10	; lenght
;	ldi	ZL, LOW(ram_array2)
;	ldi	ZH, HIGH(ram_array2)
	
;	rcall	i2c_eep_page_read


	rcall	copy_i2c_eep

MAIN:	

	rjmp	MAIN


del_i2c_eep:

	ldi	loop, 0x0
	ldi	i2c_eep_data, 0xFF

del_i2c_eep2:
	mov	i2c_eep_adr, loop
	rcall	i2c_eep_write
	
	inc	loop
	brne	del_i2c_eep2	; !=0
	
	ret
	
copy_i2c_eep:

	ldi	loop, 0x0
	ldi	ZL, 0x60
	ldi	ZH, 0x0

copy_i2c_eep2:
	mov	i2c_eep_adr, loop
	set
	rcall	i2c_eep_read
	st	Z+, i2c_eep_data
	
	inc	loop
	brne	copy_i2c_eep2	; !=0
	
	ret

	
	
	

.INCLUDE "i2c.asm"
.INCLUDE "i2c_eep_24c02.asm"

.CSEG
flash_array:		.DB "0123456789ABCDEF"
